-------------------------------------------------------------------------------
-- 
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
library fplib;
use fplib.pkg_fp_sin_cos_fsin2.all;

entity fp_sin_cos_fsin2 is
  generic ( wF : positive );
  port ( x : in  std_logic_vector(wF+2 downto 0);
         r : out std_logic_vector(wF+4 downto 0) );
end entity;

architecture arch of fp_sin_cos_fsin2 is
begin -------------------------------------------------------------------------

  fsin2_10 : if wF = 10 generate
    fsin2 : fp_sin_cos_fsin2_10
      port map ( x => x,
                 r => r );
  end generate;

  fsin2_13 : if wF = 13 generate
    fsin2 : fp_sin_cos_fsin2_13
      port map ( x => x,
                 r => r );
  end generate;

  fsin2_16 : if wF = 16 generate
    fsin2 : fp_sin_cos_fsin2_16
      port map ( x => x,
                 r => r );
  end generate;

  fsin2_20 : if wF = 20 generate
    fsin2 : fp_sin_cos_fsin2_20
      port map ( x => x,
                 r => r );
  end generate;

  fsin2_23 : if wF = 23 generate
    fsin2 : fp_sin_cos_fsin2_23
      port map ( x => x,
                 r => r );
  end generate;

end architecture; -------------------------------------------------------------
