-------------------------------------------------------------------------------
-- 
-------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
library fplib;
use fplib.pkg_fp_sin_cos_sin.all;

entity fp_sin_cos_sin is
  generic ( wF : positive );
  port ( x : in  std_logic_vector(wF+1 downto 0);
         r : out std_logic_vector(wF+2 downto 0) );
end entity;

architecture arch of fp_sin_cos_sin is
begin -------------------------------------------------------------------------

  sin_10 : if wF = 10 generate
    sin : fp_sin_cos_sin_10
      port map ( x => x,
                 r => r );
  end generate;

  sin_13 : if wF = 13 generate
    sin : fp_sin_cos_sin_13
      port map ( x => x,
                 r => r );
  end generate;

  sin_16 : if wF = 16 generate
    sin : fp_sin_cos_sin_16
      port map ( x => x,
                 r => r );
  end generate;

  sin_20 : if wF = 20 generate
    sin : fp_sin_cos_sin_20
      port map ( x => x,
                 r => r );
  end generate;

  sin_23 : if wF = 23 generate
    sin : fp_sin_cos_sin_23
      port map ( x => x,
                 r => r );
  end generate;

end architecture; -------------------------------------------------------------
